Needs["CCompilerDriver`"]

splitLibs[ll_] := Block[{libs, libnames={}, libdirs={}},
  libs = DeleteCases[StringSplit[ll], ""];
  Scan[Which[StringMatchQ[#, "-L"~~__], AppendTo[libdirs, StringDrop[#, 2]],
             StringMatchQ[#, "-l"~~__], AppendTo[libnames, StringDrop[#, 2]]]&,
       libs];
  {libdirs, libnames}
]


withlt = "/home/wiebusch/.local/opt/LoopTools"

ltsrc = DeleteCases[{"looptoolsLibraryLink.cc", "/home/wiebusch/.local/opt/LoopTools/build/libooptools.a"}, ""]

{ltlibdirs, ltlibnames} = splitLibs[" -L/home/wiebusch/.local/lib/../lib -L/usr/lib/gcc/x86_64-linux-gnu/4.9 -L/usr/lib/gcc/x86_64-linux-gnu/4.9/../../../x86_64-linux-gnu -L/usr/lib/gcc/x86_64-linux-gnu/4.9/../../../../lib -L/lib/x86_64-linux-gnu -L/lib/../lib -L/usr/lib/x86_64-linux-gnu -L/usr/lib/../lib -L. -L/home/wiebusch/.local/lib -L/usr/lib/gcc/x86_64-linux-gnu/4.9/../../.. -lgfortran -lm -lquadmath"]

(* It seems libstdc++ does not get linked automatically on all systems *)
AppendTo[ltlibnames, "stdc++"]


withlha = "yes"

lhasrc = {"LHAPDFLibraryLink.cc"}

{lhalibdirs, lhalibnames} = splitLibs["-Lyes/lib -lLHAPDF"]

(* It seems libstdc++ does not get linked automatically on all systems *)
AppendTo[lhalibnames, "stdc++"]


If[withlt =!= "",
  res = CreateLibrary[ltsrc, "looptoolsLibraryLink",
    "CompileOptions" -> "-I/home/wiebusch/.local/opt/LoopTools/build",
    "Libraries" -> ltlibnames, "LibraryDirectories" -> ltlibdirs,
    "Debug" -> True,  "ShellCommandFunction"->Print,
    "TargetDirectory" -> "."];

  If[res === $Failed, Exit[1]]
]

If[withlha =!= "",
  res = CreateLibrary[lhasrc, "LHAPDFLibraryLink",
    "CompileOptions" -> "-Iyes/include",
    "Libraries" -> lhalibnames, "LibraryDirectories" -> lhalibdirs,
    "Debug" -> True, "ShellCommandFunction"->Print,
    "TargetDirectory" -> "."];

  If[res === $Failed, Exit[1]]
]
