PrependTo[$Path, "../.."]

Needs["HEPMath`"]

(* tests = { *)
(*   DiracTr[Ga[mu].G5.Ga[nu].G5.Ga[ro].Ga[sg].G5] *)
(* }; *)

Compare[ex1_Plus, ex2_Plus] := 
  Plus @@@ ({List@@ex1, List@@ex2} //.
  {{a1___, c_, a2___}, {b1___, c_, b2___}} -> {{a1, a2}, {b1, b2}});

testCases = {
  DiracTr[Ga[mu].Ga[nu].Ga[ro].Ga[sg].Ga[lm].Ga[kp]],
  DiracTr[Ga[mu].Ga[nu].Ga[ro].Ga[sg].Ga[lm].Ga[kp].G5],
  DiracTr[Ga[mu].Ga[nu].Ga[ro].G5.Ga[sg].Ga[lm].Ga[kp]],
  DiracTr[Ga[mu].Ga[nu].G5.Ga[ro].Ga[sg].Ga[lm].Ga[kp]],
  DiracTr[Ga[mu].Ga[nu].G5.Ga[ro].G5.Ga[sg].Ga[lm].Ga[kp]],
  DiracTr[Ga[mu].Ga[nu].G5.Ga[ro].Ga[sg].Ga[lm].G5.Ga[kp]],
  DiracTr[Ga[mu].G5.Ga[nu].G5.Ga[ro].Ga[sg].Ga[lm].G5.Ga[kp]],

  DiracTr[Ga[mu].Ga[nu].Ga[ro].Ga[sg].Ga[lm].Ga[kp].Ga[xi].Ga[mu]],
  DiracTr[Ga[mu].Ga[nu].G5.Ga[ro].Ga[sg].Ga[lm].Ga[kp].Ga[xi].Ga[mu]],
  DiracTr[Ga[mu].Ga[nu].G5.Ga[ro].Ga[sg].Ga[lm].Ga[kp].G5.Ga[xi].Ga[mu]],

  DiracTr[Ga[mu].Ga[nu].Ga[ro].Ga[sg].Ga[lm].Ga[mu].Ga[xi].Ga[ro]],
  DiracTr[Ga[mu].Ga[nu].Ga[ro].Ga[sg].G5.Ga[lm].Ga[mu].Ga[xi].Ga[ro]],
  DiracTr[Ga[mu].G5.Ga[nu].Ga[ro].Ga[sg].G5.Ga[lm].Ga[mu].Ga[xi].Ga[ro]]
};

tests1 = Expand /@ (CalcDiracTraces /@ testCases);
tests2 = Expand /@ (CalcDiracTraces[#, AntiCommutingG5->True]& /@ testCases);

{comp1, comp2} = Get["tracerresults.mo"] /. {eps -> Eps, d -> Dim};


fail = False;

WriteString[$Output, "Non-commuting gamma_5:\n"];
Do[
  diff = tests1[[i]] - comp1[[i]];
  If[diff === 0,
    WriteString[$Output, "Expression"<>ToString[PaddedForm[i,2]]<>": PASS\n"]
    ,
    fail = True;
    WriteString[$Output, "Expression"<>ToString[PaddedForm[i,2]]<>": FAIL\n"];
    Print[ Compare[tests1[[i]], comp1[[i]]] ]
  ],
  {i,Length[tests1]}
];

WriteString[$Output, "Anti-commuting gamma_5:\n"];
Do[
  diff = tests2[[i]] - comp2[[i]];
  If[diff === 0,
    WriteString[$Output, "Expression"<>ToString[PaddedForm[i,2]]<>": PASS\n"]
    ,
    fail = True;
    WriteString[$Output, "Expression"<>ToString[PaddedForm[i,2]]<>": FAIL\n"];
    Print[ Compare[tests2[[i]], comp2[[i]]] ]
  ],
  {i,Length[tests2]}
];

If[fail, Exit[1], Exit[]];

